
%eval(sum(int(N1), int(N2)), N) :- !, N is N1 + N2.
%eval(mul(int(N1), int(N2)), N) :- !, N is N1 * N2.

%eval(sum(int(N),EXP), R) :- eval(EXP, N1), R is N + N1.
%eval(sum(EXP,int(N)), R) :- eval(EXP, N1), R is N + N1.
%eval(sum(EXP1,EXP2), R) :- eval(EXP1, N1), eval(EXP2, N2), R is N1 + N2.

%eval(mul(int(N),EXP), R) :- eval(EXP, N1), R is N * N1.
%eval(mul(EXP,int(N)), R) :- eval(EXP, N1), R is N * N1.
%eval(mul(EXP1,EXP2), R) :- eval(EXP1, N1), eval(EXP2, N2), R is N1 * N2.

eval(int(N1), N1).
eval(sum(EXP1,EXP2), R) :- eval(EXP1, N1), eval(EXP2, N2), R is N1 + N2.
eval(mul(EXP1,EXP2), R) :- eval(EXP1, N1), eval(EXP2, N2), R is N1 * N2.


%transform(EXP,RES) :- transform2(EXP, EXP1), EXP \= EXP1, !, transform(EXP1,RES).
%transform(EXP,RES) :- transform2(EXP, RES).

%transform2(mul(sum(EXP1,EXP2),EXP),sum(E1,E2)) :- 
%	transform2(mul(EXP1,EXP),E1),
%	transform2(mul(EXP2,EXP),E2).
%transform2(mul(EXP,sum(EXP1,EXP2)),sum(E1,E2)) :- 
%	transform2(mul(EXP,EXP1),E1),
%	transform2(mul(EXP,EXP2),E2).

%transform2(sum(EXP1, EXP2), sum(E1,E2)) :- !,
%	transform2(EXP1, E1), 
%	transform2(EXP2, E2).

%transform2(mul(EXP1, EXP2), mul(E1,E2)) :- !,
%	transform2(EXP1, E1), 
%	transform2(EXP2, E2).

%transform2(int(N), int(N)).

transform(int(N), int(N)) :- !.

transform(mul(EXP1,EXP2), sum(RES1,RES2)) :- 
	reduce(mul(EXP1,EXP2), sum(E1,E2)), 
	transform(E1,RES1),
	transform(E2,RES2).

transform(mul(EXP1,EXP2), sum(RES1,RES2)) :-
	transform(EXP1,E1),
	transform(EXP2,E2),
	reduce(mul(E1,E2), sum(RES1,RES2)).

transform(mul(EXP1,EXP2), mul(RES1,RES2)) :- 
	transform(EXP1,RES1),
	transform(EXP2,RES2).

transform(sum(EXP1,EXP2), sum(RES1,RES2)) :- 
	transform(EXP1,RES1),
	transform(EXP2,RES2).

reduce(mul(sum(EXP1,EXP2),EXP3), sum(mul(EXP1,EXP3),mul(EXP2,EXP3))) :- !.
reduce(mul(EXP3, sum(EXP1,EXP2)), sum(mul(EXP3,EXP1),mul(EXP3,EXP2))) :- !.

%inv_transform(EXP,RES) :- inv_transform2(EXP, EXP1), EXP \= EXP1, !, inv_transform(EXP1,RES).
%inv_transform(EXP,RES) :- inv_transform2(EXP, RES).

%inv_transform2(sum(mul(E1,EXP),mul(E2,EXP)), mul(sum(E1,E2),EXP)).
%inv_transform2(sum(mul(EXP,E1),mul(EXP,E2)), mul(EXP,sum(E1,E2))).

%inv_transform2(sum(EXP1,EXP2), sum(E1,E2)) :- 
%	inv_transform2(EXP1,E1), 
%	inv_transform2(EXP2, E2).

%inv_transform2(mul(EXP1,EXP2), mul(E1,E2)) :- 
%	inv_transform2(EXP1,E1), 
%	inv_transform2(EXP2, E2).

%inv_transform2(int(N), int(N)).



