
import j2p.BeanException;

import java.io.FileNotFoundException;
import java.io.StringReader;

import alice.tuprolog.InvalidTermException;

import parser.ASTExpression;
import parser.ASTStart;
import parser.Exp;
import parser.ParseException;


public class Main {

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 * @throws BeanException 
	 * @throws InvalidTermException 
	 */
	public static void main(String[] args) throws FileNotFoundException, InvalidTermException, BeanException {
		String exp1 = "((2+3)+(3*(4+2)))*8";
		System.out.println("ESPRESSIONE: " + exp1);
		Exp parser = new Exp(new StringReader(exp1));
		try {
			ASTStart goal = parser.Start();
			ASTExpression exp = (ASTExpression) goal.jjtGetChild(0);
			Integer result = Theory.eval(exp).ret0;
			System.out.println("eval -> " + result);
			ASTExpression e = Theory.transform(exp,null).ret1;
			System.out.println("transform -> " + e);
			ASTExpression e1 = Theory.transform(null,e).ret0;
			System.out.println("inv_transform -> " + e1);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		String exp2 = "((((1*2)+(2*3))+((3*4)+(4*5)))+(((5*6)+(6*7))+((7*8)+(8*9))))*10";
		System.out.println("ESPRESSIONE: " + exp2);
		parser = new Exp(new StringReader(exp2));
		try {
			ASTStart goal = parser.Start();
			ASTExpression exp = (ASTExpression) goal.jjtGetChild(0);
			Integer result = Theory.eval(exp).ret0;
			System.out.println("eval -> " + result);
			ASTExpression e = Theory.transform(exp,null).ret1;
			System.out.println("transform -> " + e);
			ASTExpression e1 = Theory.transform(null,e).ret0;
			System.out.println("inv_transform -> " + e1);
		} catch (ParseException e) {
			e.printStackTrace();
		}

	}

}
