import alice.tuprolog.*;
import java.io.*;
import parser.*;
import syntaxtree.*;
import java.util.*;
import j2p.visitor.*;
import j2p.bean.*;
import j2p.*;

public class Theory{
	private static Prolog engine = new Prolog();
	private static List<BeanInfo> beansDef = null;
	static{ 
		try{
			engine.setTheory(new alice.tuprolog.Theory(Utils.getTheory(new File("C:\\Documents and Settings\\Motonacciu\\Desktop\\Projects\\J2PExpression\\Theory.pl"))));
		} catch (InvalidTheoryException e) {
			e.printStackTrace();
			System.exit(1);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
		J2PParser parser = new J2PParser(new StringReader("parser.ASTExpression:[$parser.ASTAddExpression:sum({in/out parser.ASTExpression  Left},{in/out parser.ASTExpression  Right})|$parser.ASTMulExpression:mul({in/out parser.ASTExpression  Left},{in/out parser.ASTExpression  Right})|$parser.ASTIntegerLiteral:int({in/out java.lang.Integer  Value})] "));
		Goal root = null;
		try {
			root = parser.Goal();
		} catch (ParseException e) {
			e.printStackTrace();
		}
		beansDef = root.accept(new BeanVisitor());
	}

	public static eval_container eval(parser.ASTExpression arg0) throws BeanException{
		int[] outputs_index = new int[]{1};
		
		return PrologStub.getFirstSolution(engine,
							"eval", 
							beansDef,
							"eval(#{1},#{2})", 
							outputs_index,
							"Theory$eval_container",
							new Object[]{arg0, null});
	}
	
	public static SolutionIterator<eval_container> eval_iterator(parser.ASTExpression arg0) throws BeanException{
		int[] outputs_index = new int[]{1};
		return PrologStub.getAllSolution(engine,
							"eval", 
							beansDef,
							"eval(#{1},#{2})", 
							outputs_index,
							"Theory$eval_container",
							new Object[]{arg0, null});
	}

	public static transform_container transform(parser.ASTExpression arg0, parser.ASTExpression arg1) throws BeanException{
		int[] outputs_index = new int[]{0,1};
		
		return PrologStub.getFirstSolution(engine,
							"transform", 
							beansDef,
							"transform(#{1},#{2})", 
							outputs_index,
							"Theory$transform_container",
							new Object[]{arg0, arg1});
	}
	
	public static SolutionIterator<transform_container> transform_iterator(parser.ASTExpression arg0, parser.ASTExpression arg1) throws BeanException{
		int[] outputs_index = new int[]{0,1};
		return PrologStub.getAllSolution(engine,
							"transform", 
							beansDef,
							"transform(#{1},#{2})", 
							outputs_index,
							"Theory$transform_container",
							new Object[]{arg0, arg1});
	}



	public static class eval_container{
		public java.lang.Integer ret0;
	
		public eval_container(){}
	}

	public static class transform_container{
		public parser.ASTExpression ret0;
	public parser.ASTExpression ret1;
	
		public transform_container(){}
	}



}

